--alter table
ALTER TABLE responsavel
MODIFY email VARCHAR2(100);

--seleo
SELECT * FROM funcionario;

--projeo
SELECT cpf_f, nome FROM funcionario WHERE funcao = 'RH';

--juno natural
SELECT t.telefone FROM responsavel r, telefone_r t WHERE r.cpf_r = t.cpf_r AND r.cpf_r = 333333;

--left outer join
SELECT p.tema, i.matricula
FROM projeto p LEFT OUTER JOIN inscricao i ON p.cod_p = i.cod_p;

--right outer join
SELECT p.tema, i.matricula
FROM projeto p RIGHT OUTER JOIN inscricao i ON p.cod_p = i.cod_p;

--full outer join
SELECT p.tema, i.matricula
FROM projeto p FULL OUTER JOIN inscricao i ON p.cod_p = i.cod_p;

--consulta aninhada
SELECT i.matricula FROM inscricao i
WHERE i.escrita >(SELECT AVG(i.escrita) FROM inscricao i);

--varios AND
SELECT f.nome, f.email FROM funcionario f
WHERE f.funcao = 'professor' AND f.complemento IS NOT NULL;

--union
(SELECT nome FROM funcionario)
UNION
(SELECT nome FROM responsavel);

--intersect
(SELECT nome FROM funcionario)
INTERSECT
(SELECT nome FROM responsavel);

--minus
(SELECT nome FROM funcionario)
MINUS
(SELECT nome FROM responsavel);

--in
SELECT nome FROM funcionario WHERE funcao IN ('bibliotecario','professor');

--not in
SELECT nome FROM funcionario WHERE funcao NOT IN ('bibliotecario','professor');

--view
CREATE VIEW maiores (nome, idade, mat) AS
(SELECT a1.nome, a2.idade, a1.matricula
FROM Aluno a1 JOIN 
(SELECT matricula AS mat, 
FLOOR(MONTHS_BETWEEN(CURRENT_DATE, data_nasc)/12) AS idade FROM Aluno) a2
ON a1.matricula = a2.mat
WHERE a2.idade >= 18);

SELECT * FROM maiores;

DROP VIEW maiores;

--max
SELECT max(nota) FROM projeto;

--min
SELECT min(nota) FROM projeto;

--sum
SELECT sum(nota) FROM projeto;

--avg
SELECT avg(nota) FROM projeto;

--count
SELECT count(matricula) FROM aluno;

--operadores
SELECT escrita+1 FROM inscricao;
SELECT leitura-1 FROM inscricao;
SELECT conversacao*0.9 FROM inscricao;
SELECT nota/2 FROM projeto;

--between
SELECT cod_p FROM projeto WHERE nota BETWEEN 0 and 7;

--not between
SELECT cod_p FROM projeto WHERE nota NOT BETWEEN 0 and 5;

--like
SELECT nome FROM aluno WHERE nome LIKE '% Coelho';

--not like
SELECT nome FROM aluno WHERE nome NOT LIKE '% Coelho';

--sequence
CREATE SEQUENCE sequencia INCREMENT BY 2 MINVALUE 0 START WITH 0;
DROP SEQUENCE sequencia;

--is null
SELECT nome FROM responsavel WHERE complemento IS NULL;

--is not null
SELECT nome FROM responsavel WHERE complemento IS NOT NULL;

--order by
SELECT nome, matricula FROM aluno
ORDER BY nome;

--group by
SELECT f.nome, COUNT(T.telefone)
FROM Funcionario f, Telefone_f t
WHERE t.cpf_f = f.cpf_f
GROUP BY f.nome;

--having
SELECT r.nome, COUNT(a.cpf_r)
FROM responsavel r, aluno a
WHERE r.cpf_r = a.cpf_r
GROUP BY r.nome
HAVING COUNT(a.cpf_r) <= 2;

--alias
SELECT f.cpf_chefe AS Supervisor
FROM funcionario f;

--distinct
SELECT DISTINCT r.cpf_r, r.nome
FROM responsavel r, aluno a
WHERE a.cpf_r = r.cpf_r;

--any
SELECT nome FROM responsavel
WHERE cpf_r = ANY(SELECT cpf_f FROM funcionario WHERE funcao = 'professor');

--some
SELECT nome FROM responsavel
WHERE cpf_r = SOME(SELECT cpf_f FROM funcionario WHERE funcao = 'professor');

--all
SELECT ALL nome FROM oficina;

--exists
SELECT nome FROM aluno
WHERE EXISTS(SELECT nome FROM aluno WHERE nome like 'R%');

--not exists
SELECT nome FROM aluno
WHERE NOT EXISTS(SELECT nome FROM aluno WHERE nome like 'R%');

--create index
CREATE INDEX nomeIDX ON aluno ('Laila');

--update
UPDATE curso
SET idioma = japones WHERE cod_c = 6;

--insert into
INSERT INTO Curso (cod_c, idioma, cpf_coord) VALUES (7, 'japones', 222220);

--delete
DELETE FROM Curso WHERE cod_c = 7;

--grant
GRANT INSERT ON Curso TO PUBLIC;

--revoke
REVOKE INSERT ON Curso FROM PUBLIC;